; 
; impossible mission patch
; mailto:jp@drumfu.com
; june 2011
;
; many thanks to bandit!
;
; patch for speedlock release of
; impossible mission to fix:
;
; *1 incorrect agency message
; *2 game crash after one play through - bandit
; *3 puzzle piece placed within a terminal - bandit
; *4 password counter not reset between games - jp
; *5 screen corruption when game is won - jp
;
; as discussed within the wos forums
; http://www.worldofspectrum.org/forums/showthread.php?t=34295
;
	org $8000
;
main	ld ix,$5ccb		; load basic
	ld de,1562
	ld a,$ff
	scf
	call $0556
	jr nc,main
;
	di
	ld hl,$5efd
	push hl
	ld de,$fc83
	ld bc,$028b
	ld a,$c2
	ld r,a
	call $621f		; 1st decrypter
;
	ld hl,$fcb1
	ld de,$5f2b
	ld bc,$025d
	ld a,r
	add a,21
	set 7,a
	ld r,a
	call $fca4		; 2nd decrypter
;
	pop hl
	ld ($fcb8),hl
	ld hl,$fcfd
	dec (hl)
;
	call $fcb1		; 3rd decrypter
;
	ld hl,patch
	ld de,$5b19
	ld bc,epatch-patch
	ldir			; copy patch
;
	ld hl,$19		; reduce count of
	ld ($fed4),hl		; instructions to copy
;
	jp $fe85		; execute loader
;
patch	ld hl,$ada7		; *1*
	ld ($ad99),hl		; correct message
;
	ld hl,$0638		; *2*
	ld ($b65e),hl		; jr c,$b666
;
	ld a,$ca		; *3*
	ld ($b8e4),a		; defb $ca
	ld a,$2c
	ld ($a334),a		; ld b,$2c
;
	ld hl,$32af		; *4*
	ld ($ade5),hl		; xor a , ld (n),a
	ld hl,$bf8d		; $bf8d!
	ld ($ade7),hl
;
	ld hl,$9471		; *5*
	ld ($9904),hl		; end game patch
	ld a,$cd
	ld (hl),a		;
	ld hl,$683d
	ld ($9472),hl		; call $683d shutter
	ld ($9474),a
	ld hl,$8045
	ld ($9475),hl		; call $8045 clrscr
	ld a,$c9
	ld ($9477),a		; ret
;
	call $8045		; remainder of
	jp $b549		; original code
;
epatch	equ $
;
	end
;
